Python代码信息

运行结果
教程手册
代码仓库
极速运行
交互输入
极速运行模式,不支持键盘输入语句但是拥有更高的运行速度,输出简洁明了 。 点击编辑器上方的运行按钮即刻体验吧。
以下是用户最新保存的代码
递归版插入排序 发布于:2021-01-12 12:13 动态规划实现斐波那契 发布于:2020-12-28 18:09 dict和set 发布于:2020-12-23 23:10 list和tuple 发布于:2020-12-23 22:33 对n个数据求和。 发布于:2020-12-17 15:08 绘制小猪佩奇 发布于:2020-11-28 09:55 例2-3-2 死循环 发布于:2020-11-25 05:27 例2-3-1 有限次数的循环 发布于:2020-11-25 05:25 例2-2-2 输入0-6的整数,把它作为星期,输入对应的星期日,一直到星期六 发布于:2020-11-25 04:58 例2-2-1 输入一个学生整数成绩m,给出成绩登记A,B,C,D,E的等级。 发布于:2020-11-25 04:45 例2-1-4 输入两个整数,输出较大的一个 发布于:2020-11-25 04:31 例2-1-3 输入两个整数,输出较大的一个 发布于:2020-11-25 04:28 例2-1-2 输入一个整数,输出其绝对值 发布于:2020-11-25 04:25 例2-1-1 输入一个整数, 判断它是奇数还是偶数 发布于:2020-11-25 04:21 斐波那契数列 发布于:2020-11-25 00:23 xor 文本无密型 发布于:2020-11-13 21:19 Python学习 发布于:2020-11-13 15:36 python读写excel 发布于:2020-11-02 09:59 python实现浏览器打开指定url 发布于:2020-10-31 13:45 判断是否在范围时间内 发布于:2020-10-30 11:32 python实现浏览器打开指定url 发布于:2021-01-18 16:27 python中map的结果为什么一定要list处理? 发布于:2020-10-28 08:23 一段处理考试试题内容的代码 发布于:2020-10-25 16:59 重复元素判定。编写一个函数,接受列表作为参数,如果一个元素在列表中出现了不止一次,则返回True,但不要改变原来列表的值。同时编写调用这个函数和测试结果的程序。 发布于:2020-10-24 16:26 按个进行分组 发布于:2020-10-22 15:29 # 批量修改图片后缀名 发布于:2020-10-21 21:39 socket-服务器端 发布于:2020-10-21 11:23 socket-服务器端 发布于:2020-10-21 11:00 输入一个字符串,输出加密后的结果字符串。加密规则为: 每个字符的Unicode编码和下一个字符的Unicode编码相减, 用这个差的绝对值作为Unicode编码,对应的字符作为当前位置上字符的加密结果, 最后一个字符是和第一个字符进行运算。 发布于:2020-10-14 19:09 输入一个字符串,检查该字符串是否为回文(正着读和反着读都一样的字符串), 如果是就输出Yes,否则输出No。要求使用切片实现。 发布于:2020-10-14 17:47 输入包含若干集合的列表,输出这些集合的并集。 提示:使用reduce()函数和operator模块中的运算实现多个集合的并集。 发布于:2020-10-14 17:32 输入一个字符串,输出其中每个字符的出现次数。 要求使用标准库collections中的Counter类 发布于:2020-10-14 17:22 输入一个字符串,输出其中只出现了一次的字符及其下标。 发布于:2020-10-14 17:19 输入两个包含若干整数的等长列表,把这两个列表看作两个向量, 输出这两个向量的内积。例如输入[1,3,5,7]和[2,4,6,8],输出100。 发布于:2020-10-13 22:47 输入一个包含若干整数的列表,输出这些整数的乘积。 例如输入[-2, 3,4],输出-24。 发布于:2020-10-13 22:11 输入一个包含若干数字的列表,输出其中绝对值最大的数字。 例如输入[-8,64,3.5,-89],输出-89。 发布于:2020-10-13 21:55 输入一个包含若干自然数的列表,输出这些自然数降序排列后的新列表。例如输入[9,7,8,3,2,1,55,6],输出[55, 9, 8, 7, 6, 3, 2, 1]。 发布于:2020-10-13 21:45 输入一个包含若干自然数的列表,输出一个新列表,新列表中每个元素为原列表中 每个自然数的位数。例如输入[1,888,99,23456],输出[1,3,2,5]。 发布于:2020-10-13 21:44 输入一个包含若干自然数的列表,输出这些自然数的平均值, 结果保留3位小数。例如输入[9,7,8,3,2,1,55,6],输出11.375。 发布于:2020-10-13 21:22 接收一个正整数作为参数,返回对其进行因数分解后的结果列表。例如,接收参数50,返回[2, 5, 5]。 发布于:2020-10-10 19:34 已知参数origin和userInput是两个字符串,并且origin的长度大于userInput的长度。代码功能是统计并返回字符串origin和userInput中对应位置上相同字符的数量。 发布于:2020-10-10 15:36 python-识图点击 发布于:2020-10-07 15:35 已知参数origin和userInput是两个字符串,并且origin的长度大于userInput的长度。代码功能是统计并返回字符串origin和userInput中对应位置上相同字符的数量。 发布于:2020-10-06 21:10 计算半径为r的圆的面积,要求参数r必须为整数或浮点数并且必须大于0。 发布于:2020-10-06 21:03 Flask实现qq发消息接口(配合OPQBot) 发布于:2020-10-03 12:47 python-识图点击 发布于:2020-10-03 11:31 超星云盘(未完全实现) 发布于:2020-10-03 11:01 aiohttp爬网站(遍历index) 发布于:2020-10-03 10:59 Flask实现qq发消息接口(配合OPQBot) 发布于:2020-10-03 10:58 python-ping 发布于:2020-10-03 10:54 [更多]
显示目录

异常处理

Python 异常处理

python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。你可以使用该功能来调试python程序。

  • 异常处理: 本站Python教程会具体介绍。
  • 断言(Assertions):本站Python教程会具体介绍。

python标准异常

异常名称 描述
BaseException 所有异常的基类
SystemExit 解释器请求退出
KeyboardInterrupt 用户中断执行(通常是输入^C)
Exception 常规错误的基类
StopIteration 迭代器没有更多的值
GeneratorExit 生成器(generator)发生异常来通知退出
StandardError 所有的内建标准异常的基类
ArithmeticError 所有数值计算错误的基类
FloatingPointError 浮点计算错误
OverflowError 数值运算超出最大限制
ZeroDivisionError 除(或取模)零 (所有数据类型)
AssertionError 断言语句失败
AttributeError 对象没有这个属性
EOFError 没有内建输入,到达EOF 标记
EnvironmentError 操作系统错误的基类
IOError 输入/输出操作失败
OSError 操作系统错误
WindowsError 系统调用失败
ImportError 导入模块/对象失败
LookupError 无效数据查询的基类
IndexError 序列中没有此索引(index)
KeyError 映射中没有这个键
MemoryError 内存溢出错误(对于Python 解释器不是致命的)
NameError 未声明/初始化对象 (没有属性)
UnboundLocalError 访问未初始化的本地变量
ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
RuntimeError 一般的运行时错误
NotImplementedError 尚未实现的方法
SyntaxError Python 语法错误
IndentationError 缩进错误
TabError Tab 和空格混用
SystemError 一般的解释器系统错误
TypeError 对类型无效的操作
ValueError 传入无效的参数
UnicodeError Unicode 相关的错误
UnicodeDecodeError Unicode 解码时的错误
UnicodeEncodeError Unicode 编码时错误
UnicodeTranslateError Unicode 转换时错误
Warning 警告的基类
DeprecationWarning 关于被弃用的特征的警告
FutureWarning 关于构造将来语义会有改变的警告
OverflowWarning 旧的关于自动提升为长整型(long)的警告
PendingDeprecationWarning 关于特性将会被废弃的警告
RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
SyntaxWarning 可疑的语法的警告
UserWarning 用户代码生成的警告

什么是异常?

异常即是一个事件,该事件会在程序执行过程中发生,影响了程序的正常执行。

一般情况下,在Python无法正常处理程序时就会发生一个异常。

异常是Python对象,表示一个错误。

当Python脚本发生异常时我们需要捕获处理它,否则程序会终止执行。


异常处理

捕捉异常可以使用try/except语句。

try/except语句用来检测try语句块中的错误,从而让except语句捕获异常信息并处理。

如果你不想在异常发生时结束你的程序,只需在try里捕获它。

语法:

以下为简单的try....except...else的语法:

try:
<语句>        #运行别的代码
except <名字>:
<语句>        #如果在try部份引发了'名字'异常
except <名字>,<数据>:
<语句>        #如果引发了'名字'异常,获得附加的数据
else:
<语句>        #如果没有异常发生

try的工作原理是,当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。

  • 如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异常)。
  • 如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的try,或者到程序的最上层(这样将结束程序,并打印缺省的出错信息)。
  • 如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的话),然后控制流通过整个try语句。

实例

下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,且并未发生异常:

#!/usr/bin/python

try:
   fh = open("testfile", "w")
   fh.write("This is my test file for exception handling!!")
except IOError:
   print "Error: can\'t find file or read data"
else:
   print "Written content in the file successfully"
   fh.close()

以上程序输出结果:

 Written content in the file successfully

实例

下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,但文件没有写入权限,发生了异常:

#!/usr/bin/python

try:
   fh = open("testfile", "w")
   fh.write("This is my test file for exception handling!!")
except IOError:
   print "Error: can\'t find file or read data"
else:
   print "Written content in the file successfully"

以上程序输出结果:

Error: can't find file or read data

使用except而不带任何异常类型

你可以不带任何异常类型使用except,如下实例:

try:
   You do your operations here;
   ......................
except:
   If there is any exception, then execute this block.
   ......................
else:
   If there is no exception then execute this block.

以上方式try-except语句捕获所有发生的异常。但这不是一个很好的方式,我们不能通过该程序识别出具体的异常信息。因为它捕获所有的异常。



使用except而带多种异常类型

你也可以使用相同的except语句来处理多个异常信息,如下所示:

try:
   You do your operations here;
   ......................
except(Exception1[, Exception2[,...ExceptionN]]]):
   If there is any exception from the given exception list, 
   then execute this block.
   ......................
else:
   If there is no exception then execute this block.

try-finally 语句

try-finally 语句无论是否发生异常都将执行最后的代码。

try:
<语句>
finally:
<语句>    #退出try时总会执行
raise

注意:你可以使用except语句或者finally语句,但是两者不能同时使用。else语句也不能与finally语句同时使用

实例

#!/usr/bin/python

try:
   fh = open("testfile", "w")
   fh.write("This is my test file for exception handling!!")
finally:
   print "Error: can\'t find file or read data"

如果打开的文件没有可写权限,输出如下所示:

Error: can't find file or read data

同样的例子也可以写成如下方式:

#!/usr/bin/python

try:
   fh = open("testfile", "w")
   try:
      fh.write("This is my test file for exception handling!!")
   finally:
      print "Going to close the file"
      fh.close()
except IOError:
   print "Error: can\'t find file or read data"

当在try块中抛出一个异常,立即执行finally块代码。

finally块中的所有语句执行后,异常被再次提出,并执行except块代码。

参数的内容不同于异常。


异常的参数

一个异常可以带上参数,可作为输出的异常信息参数。

你可以通过except语句来捕获异常的参数,如下所示:

try:
   You do your operations here;
   ......................
except ExceptionType, Argument:
   You can print value of Argument here...

变量接收的异常值通常包含在异常的语句中。在元组的表单中变量可以接收一个或者多个值。

元组通常包含错误字符串,错误数字,错误位置。

实例

以下为单个异常的实例:

#!/usr/bin/python

# 定义函数
def temp_convert(var):
   try:
      return int(var)
   except ValueError, Argument:
      print "The argument does not contain numbers\n", Argument

# 调用函数
temp_convert("xyz");

以上程序执行结果如下:

The argument does not contain numbers
invalid literal for int() with base 10: 'xyz'

触发异常

我们可以使用raise语句自己触发异常

raise语法格式如下:

raise [Exception [, args [, traceback]]]

语句中Exception是异常的类型(例如,NameError)参数是一个异常参数值。该参数是可选的,如果不提供,异常的参数是"None"。

最后一个参数是可选的(在实践中很少使用),如果存在,是跟踪异常对象。

实例

一个异常可以是一个字符串,类或对象。 Python的内核提供的异常,大多数都是实例化的类,这是一个类的实例的参数。

定义一个异常非常简单,如下所示:

def functionName( level ):
    if level < 1:
        raise Exception("Invalid level!", level)
        # 触发异常后,后面的代码就不会再执行

注意:为了能够捕获异常,"except"语句必须有用相同的异常来抛出类对象或者字符串。

例如我们捕获以上异常,"except"语句如下所示:

try:
   Business Logic here...
except "Invalid level!":
   Exception handling here...
else:
   Rest of the code here...

用户自定义异常

通过创建一个新的异常类,程序可以命名它们自己的异常。异常应该是典型的继承自Exception类,通过直接或间接的方式。

以下为与RuntimeError相关的实例,实例中创建了一个类,基类为RuntimeError,用于在异常触发时输出更多的信息。

在try语句块中,用户自定义的异常后执行except块语句,变量 e 是用于创建Networkerror类的实例。

class Networkerror(RuntimeError):
   def __init__(self, arg):
      self.args = arg

在你定义以上类后,你可以触发该异常,如下所示:

try:
   raise Networkerror("Bad hostname")
except Networkerror,e:
   print e.args

异常处理代码执行说明:

#!/usr/bin/python
# -*- coding: UTF-8 -*-

#This is note foe exception

try:
  code    #需要判断是否会抛出异常的代码,如果没有异常处理,python会直接停止执行程序

except:  #这里会捕捉到上面代码中的异常,并根据异常抛出异常处理信息
#except ExceptionName,args:    #同时也可以接受异常名称和参数,针对不同形式的异常做处理

  code  #这里执行异常处理的相关代码,打印输出等

else:  #如果没有异常则执行else

  code  #try部分被正常执行后执行的代码

finally:
  code  #退出try语句块总会执行的程序

#函数中做异常检测
def try_exception(num):
  try:
    return int(num)
  except ValueError,arg:
    print arg,"is not a number"
  else:
    print "this is a number inputs"

try_exception('xxx')

#输出异常值
Invalide literal for int() with base 10: 'xxx' is not a number
由JSRUN为你提供的Python在线工具
        JSRUN提供的Python在线运行,Python 在线编译工具,基于linux操作系统环境提供线上编译和线上运行,具有运行快速,运行结果与常用开发、生产环境保持一致的特点。

title

使用此草稿 删除草稿

皮肤:

运行模式:

嵌入代码 iframe嵌入: